
 -- AutoKick 4.3.01

	-- Create table
	if not AutoKickDB then AutoKickDB = {} end
	local AutoKickAch = AchievementAlertFrame_GetAlertFrame()

	local function AKachieve()
		_G[AutoKickAch:GetName().."Name"]:SetText("AutoKick!")
		_G[AutoKickAch:GetName().."IconTexture"]:SetTexture("")
		AlertFrame_AnimateIn(AutoKickAch)
		PlaySoundFile("Sound\\Spells\\AchievmentSound1.ogg")
	end

	-- AutoKick function
	local function AutoKickFunc()

		if not CanGuildRemove() then
			DEFAULT_CHAT_FRAME:AddMessage("You don't have permission to kick!", 1,0.85,0.5)
			return
		end

		local realsuccess = false;

		GuildRoster()
		for i=1,GetNumGuildMembers() do
			local years, months, days = GetGuildRosterLastOnline(i)
			if (years) and (years >= 0 and months >= 0 and days >= AutoKickDB["AKlastlog"]) then
				local _, _, _, _, _, _, note = GetGuildRosterInfo(i)
				if (note == "" and AutoKickDB["AutoKickNote"] == "On") or (AutoKickDB["AutoKickNote"] == "Off") then
					GuildUninvite(GetGuildRosterInfo(i))
					realsuccess = true;
				end
			end
		end
		if realsuccess then AKachieve() end;
	end

	-- Define options panel title
	local function AKtitle(title,subtitle,frame)
		local text = frame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalLarge')
		text:SetPoint('TOPLEFT', 16, -16); text:SetText(title)
		local subtext = frame:CreateFontString(nil, 'ARTWORK', 'GameFontHighlightSmall')
		subtext:SetHeight(32);
		subtext:SetPoint('TOPLEFT', text, 'BOTTOMLEFT', 0, -8); subtext:SetPoint('RIGHT', frame, -32, 0)
		subtext:SetJustifyH('LEFT'); subtext:SetJustifyV('TOP');
		subtext:SetNonSpaceWrap(true); subtext:SetText(subtitle)
	end

	-- Define subheadings
	local function AKtext(title,x,y,frame)
		local text = frame:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
		text:SetPoint("TOPLEFT",x,y)
		text:SetText(title)
	end

	-- Define Checkbox control
	local function AKcheckbox(field,caption,x,y,frame)
		local checkbox = CreateFrame('CheckButton', field, frame, "ChatConfigCheckButtonTemplate")
		_G[checkbox:GetName() .. 'Text']:SetText(caption)
		checkbox:SetScript('OnShow', function(frame) 
			frame:SetChecked(AutoKickDB[field]) 
		end)
		checkbox:SetScript('OnClick', function(frame)
		if checkbox:GetChecked() == nil then
			AutoKickDB[field] = "Off"
		elseif checkbox:GetChecked() == 1 then
			AutoKickDB[field] = "On"
		end
		end)
		checkbox:SetPoint("TOPLEFT",x, y)
	end

	-- Define slider control
	local function AKslider(name, field, caption, low, high, step, x,y, form, sliderLtext, sliderRtext, frame)

		local name = CreateFrame('slider', field, frame, 'OptionssliderTemplate')
		_G[name:GetName() .. 'Text']:SetText(caption)

		name:SetMinMaxValues(low, high)
		name:SetValueStep(step)
		name:EnableMouseWheel(true)
		name:SetPoint('TOPLEFT', x,y)
		name.tooltipText = "Drag the slider."
		name:SetWidth(100)
		name:SetHeight(20)
		name:SetScript('OnMouseWheel', function(frame, arg1)
			local step = frame:GetValueStep() * arg1
			local value = frame:GetValue()
			local minVal, maxVal = frame:GetMinMaxValues()
			if step > 0 then
				frame:SetValue(min(value+step, maxVal))
			else
				frame:SetValue(max(value+step, minVal))
			end
		end)
		name:SetScript('OnValueChanged', function(frame, value)
			frame.valText:SetText(format(form, value))
			AutoKickDB[field] = value
		end)
		name:SetScript('OnShow', function(frame)
			frame.onShow = true
			frame:SetValue(AutoKickDB[field])
			frame.onShow = nil
		end)

		_G[name:GetName() .. 'Low']:SetText(sliderLtext);
		_G[name:GetName() .. 'High']:SetText(sliderRtext);

		local text = name:CreateFontString(nil, 'BACKGROUND')
		text:SetFontObject('GameFontHighlight')
		text:SetPoint('LEFT', name, 'RIGHT', 12, 0)
		name.valText = text
		text:SetText(string.format("%.2f", name:GetValue()))

	end

	-- Define close button
	local function AKclose(name,frame,anchor,x,y,width,height)
		local name = CreateFrame("Button", name, frame, "UIPanelCloseButton") 
		name:SetWidth(width)
		name:SetHeight(height) 
		name:SetPoint(anchor, x, y)
	end

	-- Create options panel
	local AKframe = CreateFrame("FRAME", "AKframe", UIParent)
 	AKframe:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	AKframe:SetSize(400,250)
	AKframe:Hide();

	-- Add close button
	AKclose("AKclosebutton",AKframe,"TOPRIGHT",0, 0, 30, 30)
	AKclosebutton:SetScript("OnClick", function() 
		AKframe:Hide();
	end)

	-- Background color
	AKframe.t = AKframe:CreateTexture("AKframe", "BACKGROUND")
	AKframe.t:SetAllPoints()
	AKframe.t:SetTexture(0.05, 0.05, 0.05, 0.9)

	-- Details
	AKtitle("AutoKick",(select(3, GetAddOnInfo("AutoKick"))),AKframe);
	AKtext("Options",16,-72,AKframe)
	AKcheckbox("AutoKickNote", "Only kick people with no guild note", 16, -92,AKframe)
	AKtext("Offline for (at least) how many days?",16,-132,AKframe)
	AKslider("AKsliderbar","AKlastlog","",1, 28, 1, 28, -162,"%.0f", "10", "28", AKframe)

	-- Add kick button
	local AutoKickButton = CreateFrame("Button", "AutoKickNow", AKframe, "UIPanelButtonTemplate") 
	AutoKickButton:SetWidth(70)
	AutoKickButton:SetHeight(25) 
	AutoKickButton:SetPoint("TOPLEFT", 16, -212)
	AutoKickButton:SetText("Kick!") 
	AutoKickButton:RegisterForClicks("AnyUp") 
	AutoKickButton:SetScript("OnClick", function()
		AutoKickFunc()
	end)

	-- Slash command
	SLASH_AutoKick1 = "/ak"
	SlashCmdList["AutoKick"] = function()
		if AKframe:IsShown() then
			AKframe:Hide();
		else
			AKframe:Show();
		end
	end

	AKframe:RegisterEvent("ADDON_LOADED")
	AKframe:RegisterEvent("PLAYER_LOGOUT")
	AKframe:SetScript("OnEvent", function(self,event,arg1)
		if event == "ADDON_LOADED" and arg1 == "AutoKick" then
			if not (AutoKickDB["AutoKickNote"]) then AutoKickDB["AutoKickNote"] = "On" end
			if not (AutoKickDB["AKlastlog"]) then AutoKickDB["AKlastlog"] = "16" end
		end
	end)	
